
defmodule SSV do  # stack server

  def go do # makes a stack process, and a process to push onto it
    pid = spawn_link(__MODULE__, :loop, [[]])
    _pid2 = spawn_link(__MODULE__, :second, [pid,1])
    {:ok, pid}
  end

  def new do  # makes a stack process
    pid = spawn_link(__MODULE__, :loop, [[]])
    {:ok, pid}
  end

  def push(pid, item) do send( pid, {:push, item} ) end

  def pop(pid) do send( pid, {:pop} ) end

  def size(pid) do
    send( pid, {:size, self()} )
    receive do {:ok, size} -> size end
  end

  def top(pid) do 
    send( pid, {:top, self()} ) 
    receive do {:ok, item} -> item end
  end

  def loop(stack) do
    receive do
      {:push, item} -> 
        loop([item|stack])
      {:pop} -> 
        if stack == [] do loop(stack) end
        loop(tl(stack))
      {:top, sender} ->
        if stack != [] do send(sender, {:ok, hd(stack)})
        else send(sender, {:ok, nil})
        end
        loop(stack)
      {:size, sender} ->
        send(sender, {:ok, Enum.count(stack)})
        loop(stack)
    end
  end

  def second(st,n) do
    SSV.push(st,{:second, n})
    :timer.sleep(20000)
    second(st, n+1)
  end

end
